;==================================================
; Beet Platform
; By Erik
;
; This 32x64 platform will fall when Mario jumps
; on it, sinking slowly while on lava.
; By design, it'll survive after it passes a body
; of lava.
; GFX / idea by Saturnyoshi - he made it in SMBX.
;==================================================

tilemap:
        db $88,$88
        db $8E,$EE,$AE,$80,$CE,$A0

;---

if !SA1 = 1
        !wram   = $40
else
        !wram   = $7E
endif

if !EXLEVEL
        !LookupRAM      = $0BF6|!Base2
        !L1_Lookup_Lo   = !LookupRAM+96+96
        !L1_Lookup_Hi   = !LookupRAM+96+96+32
endif

;---

print "MAIN ",pc
        PHB
        PHK
        PLB
        JSR beet_platform
        PLB
print "INIT ",pc
        RTL

;---

beet_platform:
        JSR draw_sprite
        LDA !14C8,x
        EOR #$08
        ORA $9D
        BNE .return
        LDA !AA,x
        BEQ .check_interact
        LDA #$2A
        STA $00
        JSR obj_interact
        BCS +
        LDA #$08
        STA $00
        JSR obj_interact
+       LDA !1540,x
        BNE +
        LDA !AA,x
        CMP #$40
        BPL +
        INC #2
        STA !AA,x
+       JSL $01801A|!BankB
.check_interact
        JSR interaction
        BCC .return
        LDA !AA,x
        BNE .return
        LDA #$03
        STA !AA,x
        LDA #$18
        STA !1540,x
.return
        RTS

;-

obj_interact:
        LDA !D8,x
        CLC
        ADC $00
        AND #$F0
        STA $06
        LDA !14D4,x
        ADC #$00
        STA $99
        LDA !14E0,x
        STA $9B
        LDA !E4,x
        LSR #4
        ORA $06
        PHA
        LDA $5B
        LSR
        PLA
        BCC .horz
        LDX $99
        CLC
        ADC.l $00BA80,x
        STA $05
        LDA.l $00BABC,x
        ADC $9B
        STA $06
        BRA .common

.horz
        LDX $9B
if !EXLEVEL
        ADC.l !L1_Lookup_Lo,x
        STA $05
        LDA.l !L1_Lookup_Hi,x
else
        ADC.l $00BA80,x
        STA $05
        LDA.l $00BA9C,x
endif
        ADC $99
        STA $06
.common
        LDA.b #!wram
        STA $07
        LDX $15E9|!Base2
        LDA [$05]
        CMP #$06
        BCC .liquid
        CMP #$FB
        BCS .liquid
        STZ !164A,x
        CLC
        RTS
.liquid
        LDA #$01
        STA !164A,x
        LDA !AA,x
        CMP #$04
        BCC +
        LDA #$04
        STA !AA,x
+       SEC
        RTS

;-

interaction:
        LDA !E4,x
        STA $04
        LDA !D8,x
        STA $05
        LDA !14E0,x
        STA $0A
        LDA !14D4,x
        STA $0B
        LDA #$20
        STA $06
        LDA #$2A
        STA $07
        JSL $03B664|!BankB
        JSL $03B72B|!BankB
        BCC .return
        LDA !D8,x
        SBC $1C
        STA $00
        LDA $80
        CLC
        ADC #$18
        CMP $00
        BPL .arLabel58
        LDA $7D
        BMI .no_interact
        LDA $77
        AND #$08
        BNE .no_interact
        LDA #$10
        STA $7D
        LDA #$01
        STA $1471|!Base2
        LDA #$1F
        LDY $187A|!Base2
        BEQ +
        LDA #$2F
+       STA $01
        LDA !D8,x
        SEC
        SBC $01
        STA $96
        LDA !14D4,x
        SBC #$00
        STA $97
        LDA $77
        AND #$03
        BNE .interacted
        LDY #$00
        LDA !1528,x
        BPL +
        DEY
+       CLC
        ADC $94
        STA $94
        TYA
        ADC $95
        STA $95
.interacted
        SEC
.return
        RTS

.no_interact
        CLC
        RTS

.arLabel58
        LDA #$00
        LDY $73
        BNE +
        LDY $19
        BNE ++
+       LDA #$08
++      LDY $187A|!Base2
        BEQ +
        ADC #$08
+       CLC
        ADC $80
        CMP $00
        BCC .arLabelA9
        LDA $7D
        BPL .no_interact
        LDA #$10
        STA $7D
        LDA #$01
        STA $1DF9|!Base2
        CLC
        RTS

.DATA_01B4F9
        db $1F,$F1
.DATA_01B4FF
        db $00,$FF

.arLabelA9
        %SubHorzPos()
        LDA .DATA_01B4F9,y
        CLC
        ADC $E4,x
        STA $94
        LDA .DATA_01B4FF,y
        ADC $14E0,x
        STA $95
        STZ $7B
        CLC
        RTS

;-

x_disp:
        db $00,$10,$00,$10,$00,$10,$00,$10
y_disp:
        db $F0,$F0,$00,$00,$10,$10,$20,$20

draw_sprite:
        LDA $64
        PHA
        LDA !164A,x
        BEQ +
        LDA #$10
        STA $64
+       %GetDrawInfo()
        STZ $02
        LDA !15F6,x
        ORA $64
        STA $03
        PLA
        STA $64
        LDX #$07
-       LDA #$00
        CPX #$01
        BNE +
        LDA #$40
+       ORA $03
        STA $0303|!Base2,y
        LDA $00
        CLC
        ADC x_disp,x
        STA $0300|!Base2,y
        LDA $01
        CLC
        ADC y_disp,x
        STA $0301|!Base2,y
        LDA tilemap,x
        STA $0302|!Base2,y
        INY #4
        DEX
        BPL -
        LDX $15E9|!Base2
        LDY #$02
        LDA #$07
        JSL $01B7B3|!BankB
        RTS

